"use strict";

var _parser = require("@elodin/parser");

var _index = require("../../index");

var _fela = _interopRequireDefault(require("../fela"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var file = "\nvariant Type {\n  Primary\n  Secondary\n}\n\nvariant Mode {\n  Dark\n  Light\n}\n\nview Button {\n  __border: 0\n  backgroundColor: red\n  paddingLeft: 10\n  borderWidth: $borderWidth\n  [Type=Primary] {\n    backgroundColor: red\n    paddingLeft: $paddingLeft\n\n    [@hover] {\n      paddingLeft: 10\n      paddingRight: $paddingRight\n    }\n    [Mode=Dark] {\n      backgroundColor: blue\n      paddingLeft: $padLeft\n    }\n  }\n  [Mode=Light] {\n    backgroundColor: green\n  }\n}\n\ntext Label {\n  lineHeight: $lineHeight\n\n  [@hover] {\n    color: red\n    fontSize: $fontSize\n  }\n\n  [@viewportWidth>=320] {\n    color: green\n    fontSize: $mediaFontSize\n    [@hover] {\n      fontSize: $mediaHoverFontSize\n      color: blue\n    }\n  }\n}";
describe('Compiling to CSS and JavaScript using fela', function () {
  it('should return a map of files', function () {
    var _parse = (0, _parser.parse)(file),
        ast = _parse.ast;

    expect((0, _index.createGenerator)({
      adapter: (0, _fela["default"])()
    })(ast, 'index.elo')).toMatchSnapshot();
  });
  it('should pass adapter configuration', function () {
    var _parse2 = (0, _parser.parse)(file),
        ast = _parse2.ast;

    expect((0, _index.createGenerator)({
      adapter: (0, _fela["default"])({
        reactFela: true,
        dynamicImport: true
      })
    })(ast, 'index.elo')).toMatchSnapshot();
  });
});