"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = glamorAdapter;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function stringifyDeclaration(declaration) {
  var prop = '"' + declaration.property + '":';

  if (_typeof(declaration.value) === 'object') {
    return prop + '{' + declaration.value.map(stringifyDeclaration).join(',\n') + '}';
  }

  return prop + declaration.value;
}

var defaultConfig = {
  dynamicImport: false
};

function glamorAdapter() {
  var customConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var _defaultConfig$custom = _objectSpread({}, defaultConfig, {}, customConfig),
      dynamicImport = _defaultConfig$custom.dynamicImport;

  return function (_ref) {
    var style = _ref.style,
        variantStyleMap = _ref.variantStyleMap,
        className = _ref.className,
        cssFileName = _ref.cssFileName,
        resetClassName = _ref.resetClassName,
        classNameMap = _ref.classNameMap,
        moduleName = _ref.moduleName;
    var hasVariations = Object.keys(classNameMap).length > 1;
    var hasDynamicVariations = Object.keys(variantStyleMap).length > 0;
    var imports = [hasVariations ? 'getClassNameFromVariantMap' : undefined, hasDynamicVariations ? 'getDynamicStyleFromVariantMap' : undefined].filter(Boolean);
    return (!dynamicImport ? "import './" + cssFileName + ".css'\n" : '') + "import { css } from 'glamor'\n" + (imports.length > 0 ? 'import { ' + imports.join(', ') + " } from '@elodin/runtime'\n\n" : '\n') + (hasVariations ? 'const variantClassNameMap = ' + JSON.stringify(classNameMap, null, 2) + '\n\n' : '') + (hasDynamicVariations ? 'const variantStyleMap = {\n' + Object.keys(variantStyleMap).map(function (modifier) {
      return "'" + modifier + "'" + ': (props = {}) => ({\n  ' + variantStyleMap[modifier].map(stringifyDeclaration).join(',\n  ') + '\n})';
    }).join(',\n') + '\n}' + '\n\n' : '') + 'export function ' + moduleName + '(props = {})' + ' {\n  ' + (dynamicImport ? "import('./" + cssFileName + ".css')\n  " : '') + 'const className = ' + (hasVariations ? "'" + resetClassName + " ' + " + "getClassNameFromVariantMap('" + className + "', variantClassNameMap, props)" : "'" + resetClassName + ' ' + className + "'") + '\n\n  ' + 'return className + " " + css({\n    ' + style.map(stringifyDeclaration).join(',\n    ') + (hasDynamicVariations ? ',\n    ...getDynamicStyleFromVariantMap(variantStyleMap, props)' : '') + '\n  })\n}';
  };
}